package com.toast.android.sample.toast.logncrash;

import com.toast.android.logncrash.SendMode;
import com.toast.android.logncrash.ToastLog;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.view.View;
import android.widget.EditText;
import android.widget.Toast;
import android.widget.ToggleButton;

public class ToastLogSample extends Activity implements View.OnClickListener {
	

	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.sample_layout);

		findViewById(R.id.initialize).setOnClickListener(this);
		findViewById(R.id.enable_logcat_main).setOnClickListener(this);
		findViewById(R.id.enable_logcat_radio).setOnClickListener(this);
		findViewById(R.id.enable_logcat_event).setOnClickListener(this);
		findViewById(R.id.enable_init_log).setOnClickListener(this);
		findViewById(R.id.debug).setOnClickListener(this);
		findViewById(R.id.info).setOnClickListener(this);
		findViewById(R.id.warn).setOnClickListener(this);
		findViewById(R.id.error).setOnClickListener(this);
		findViewById(R.id.fatal).setOnClickListener(this);
		findViewById(R.id.handled_debug).setOnClickListener(this);
		findViewById(R.id.handled_info).setOnClickListener(this);
		findViewById(R.id.handled_fatal).setOnClickListener(this);
		findViewById(R.id.send_crash).setOnClickListener(this);
		findViewById(R.id.crash_type2).setOnClickListener(this);
		findViewById(R.id.crash_type3).setOnClickListener(this);
		findViewById(R.id.crash).setOnClickListener(this);
		
		((EditText) findViewById(R.id.appkey)).setText("PoRdJzY3s6tyDVcuW1rmQnWxgwNAMRMMCU7b0ExxFoQFxHji0tH7fiQu81cekLRc");
		((EditText) findViewById(R.id.version)).setText("1.0.0.g");
		((EditText) findViewById(R.id.collector_address)).setText("http://api-logncrash.cloud.toast.com");
		((EditText) findViewById(R.id.collector_port)).setText("80");
		((EditText) findViewById(R.id.log_source)).setText(ToastLog.DEFAULT_LOG_SOURCE);
		((EditText) findViewById(R.id.log_type)).setText(ToastLog.DEFAULT_LOG_TYPE);

		updateViews();
	}

	@Override
	public void onClick(View v) {
		switch (v.getId()) {
		case R.id.initialize: {
			String collectorAddr = ((EditText) findViewById(R.id.collector_address)).getText().toString();
			int collectorPort = Integer.parseInt(((EditText) findViewById(R.id.collector_port)).getText().toString());
			String appKey = ((EditText) findViewById(R.id.appkey)).getText().toString();
			String version = ((EditText) findViewById(R.id.version)).getText().toString();
			
			
			//ToastLog.setSendMode(SendMode.ONLY_WIFI_WITHOUT_FILE_SAVE	);
			//ToastLog.setDeduplicate(false);
			if (ToastLog.initialize(getApplication(), collectorAddr, collectorPort, appKey, version)) {
				
			
				((EditText) findViewById(R.id.appkey)).setText(ToastLog.getAppKey());
				((EditText) findViewById(R.id.version)).setText(ToastLog.getVersion());
				((EditText) findViewById(R.id.collector_address)).setText(ToastLog.getCollectorAddr());
				((EditText) findViewById(R.id.collector_port)).setText("" + ToastLog.getCollectorPort());

				Toast.makeText(this, "Initialize", Toast.LENGTH_SHORT).show();
			} else {
				Toast.makeText(this, "Fail to initialize", Toast.LENGTH_SHORT).show();
			}
			updateViews();
			break;
		}

		case R.id.enable_logcat_main: {
			finish(); 
			break;
		}
		case R.id.enable_logcat_radio: {
			ToggleButton b = (ToggleButton) findViewById(R.id.enable_logcat_radio);
			ToastLog.setEnableLogcatRadio(b.isChecked());
			updateViews();
			break;
		}
		case R.id.enable_logcat_event: {
			ToggleButton b = (ToggleButton) findViewById(R.id.enable_logcat_event);
			ToastLog.setEnableLogcatEvents(b.isChecked());
			updateViews();
			break;
		}
		case R.id.enable_init_log: {
			if (ToastLog.isInitialized()) {
				Toast.makeText(this, "Already initialize", Toast.LENGTH_SHORT).show();
			} else {
				ToggleButton b = (ToggleButton) findViewById(R.id.enable_init_log);
				ToastLog.setSendInitLog(b.isChecked());
			}
			updateViews();
			break;
		}

		case R.id.debug: {
			if (ToastLog.isInitialized()) {
				String message = ((EditText) findViewById(R.id.message)).getText().toString(); 
				ToastLog.debug(message);
			} else {
				Toast.makeText(this, "Not initialize", Toast.LENGTH_SHORT).show();
			}
			break;
		}
		case R.id.info: {
			
			Handler handler = new Handler();

			final Runnable r = new Runnable() {
			    public void run() {
			      for(int i = 0; i < 10; i++)
			    	ToastLog.info("hello world : " + i);
			    }
			};

			handler.postDelayed(r, 0);
			
			break;
		}
		case R.id.warn: {
			if (ToastLog.isInitialized()) {
				String message = ((EditText) findViewById(R.id.message)).getText().toString();
				ToastLog.warn(message);
			} else {
				Toast.makeText(this, "Not initialize", Toast.LENGTH_SHORT).show();
			}
			break;
		}
		case R.id.error: {
			if (ToastLog.isInitialized()) {
				String message = ((EditText) findViewById(R.id.message)).getText().toString(); 
				ToastLog.error(message);
			} else {
				Toast.makeText(this, "Not initialize", Toast.LENGTH_SHORT).show();
			}
			break;
		}
		case R.id.fatal: {
			if (ToastLog.isInitialized()) {
				String message = ((EditText) findViewById(R.id.message)).getText().toString();
				ToastLog.fatal(message);
			} else {
				Toast.makeText(this, "Not initialize", Toast.LENGTH_SHORT).show();
			}
			break;
		}

		case R.id.handled_debug: {
			if (ToastLog.isInitialized()) {
				clickHandledDebug();
			} else {
				Toast.makeText(this, "Not initialize", Toast.LENGTH_SHORT).show();
			}
			break;
		}
		case R.id.handled_info: {
			if (ToastLog.isInitialized()) {
				clickHandledInfo();
			} else {
				Toast.makeText(this, "Not initialize", Toast.LENGTH_SHORT).show();
			}
			break;
		}
		case R.id.handled_fatal: {
			if (ToastLog.isInitialized()) {
				clickHandledFatal();
			} else {
				Toast.makeText(this, "Not initialize", Toast.LENGTH_SHORT).show();
			}
			break;
		}

		case R.id.send_crash: {
			if (ToastLog.isInitialized()) {
				clickSendCrash();
			} else {
				Toast.makeText(this, "Not initialize", Toast.LENGTH_SHORT).show();
			}
			break;
		}
		case R.id.crash_type2: {
			if (ToastLog.isInitialized()) {
				clickSendCrash2();
			} else {
				Toast.makeText(this, "Not initialize", Toast.LENGTH_SHORT).show();
			}
			break;
		}
		case R.id.crash_type3: {
			if (ToastLog.isInitialized()) {
				clickSendCrash3();
			} else {
				Toast.makeText(this, "Not initialize", Toast.LENGTH_SHORT).show();
			}
			break;
		}
		case R.id.crash: {
			if (ToastLog.isInitialized()) {
				clickCrash();
			} else {
				Toast.makeText(this, "Not initialize", Toast.LENGTH_SHORT).show();
			}
			break;
		}

		default:
			Toast.makeText(this, "NO ACTION", Toast.LENGTH_SHORT).show();
			break;
		}
	}

	public void clickHandledDebug() {
		// Make a ArrayIndexOutOfBoundsException
		try {
			int[] a = new int[4];
			a[10] = 10;
		} catch (Exception e) {
			String message = ((EditText) findViewById(R.id.message)).getText().toString(); 
			ToastLog.debug(message + " " + e.toString(), e);
		}
	}
	public void clickHandledInfo() {
		// Make a NullPointerException
		try {
			Object a = null;
			a.toString();
		} catch (Exception e) {
			String message = ((EditText) findViewById(R.id.message)).getText().toString(); 
			ToastLog.info(message + " " + e.toString(), e);
		}
	}
	public void clickHandledFatal() {
		// Make a ClassCastException
		try {
			Object f = Float.valueOf(10f);
			@SuppressWarnings("unused")
			Integer i = (Integer) f;
		} catch (Exception e) {
			String message = ((EditText) findViewById(R.id.message)).getText().toString(); 
			ToastLog.fatal(message + " " + e.toString(), e);
		}
	}
	public void clickSendCrash() {
		// Make a NumberFormatException
		try {
			Integer.parseInt("10abc");
		} catch (Exception e) {
			String message = ((EditText) findViewById(R.id.message)).getText().toString(); 
			ToastLog.crash(message + " " + e.toString(), e);
		}
	}
	public void clickSendCrash2() {
		// Make a NumberFormatException
		try {
			int [] intArray = { 1, 2, 3, 4 };
			int res = intArray[4];

		} catch (Exception e) {
			String message = ((EditText) findViewById(R.id.message)).getText().toString(); 
			ToastLog.crash(message + " " + e.toString(), e);
		}
	}
	public void clickSendCrash3(){
		// Make a NumberFormatException
		try {
			int n = 5/0;
			
		} catch (Exception e) {
			String message = ((EditText) findViewById(R.id.message)).getText().toString(); 
			ToastLog.crash(message + " " + e.toString(), e);
		}
	}
	public void clickCrash() {
		//Make a ArithmathicException!!
		@SuppressWarnings("unused")
		int a = 10 / 0;
	}

	private void updateViews() {
		boolean isInit = ToastLog.isInitialized();

		findViewById(R.id.appkey).setEnabled(!isInit);
		findViewById(R.id.version).setEnabled(!isInit);
		findViewById(R.id.collector_address).setEnabled(!isInit);
		findViewById(R.id.collector_port).setEnabled(!isInit);

		findViewById(R.id.initialize).setEnabled(!isInit);
		findViewById(R.id.enable_init_log).setEnabled(!isInit);

		findViewById(R.id.debug).setEnabled(isInit);
		findViewById(R.id.info).setEnabled(isInit);
		findViewById(R.id.warn).setEnabled(isInit);
		findViewById(R.id.error).setEnabled(isInit);
		findViewById(R.id.fatal).setEnabled(isInit);
		findViewById(R.id.handled_debug).setEnabled(isInit);
		findViewById(R.id.handled_info).setEnabled(isInit);
		findViewById(R.id.handled_fatal).setEnabled(isInit);
		findViewById(R.id.crash).setEnabled(isInit);
		findViewById(R.id.send_crash).setEnabled(isInit);
		findViewById(R.id.crash_type2).setEnabled(isInit);
		findViewById(R.id.crash_type3).setEnabled(isInit);

		((ToggleButton) findViewById(R.id.enable_logcat_main)).setChecked(ToastLog.getEnableLogcatMain());
		((ToggleButton) findViewById(R.id.enable_logcat_radio)).setChecked(ToastLog.getEnableLogcatRadio());
		((ToggleButton) findViewById(R.id.enable_logcat_event)).setChecked(ToastLog.getEnableLogcatEvents());
		((ToggleButton) findViewById(R.id.enable_init_log)).setChecked(ToastLog.getSendInitLog());
	}
}
